package com.vendor.burn.utilitily;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.log.Log;
import com.vendor.burn.model.PCNetworkInfo;
import com.vendor.burn.utilitily.CmdUtils;
import com.vendor.burn.utilitily.FileUtils;
import com.vendor.burn.utilitily.ToolUtils;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Random;
import java.util.StringTokenizer;
import org.eclipse.swt.widgets.Display;

public class IPUtils {
  private static final String KEY_INTERFACES = "HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\services\\Tcpip\\Parameters\\Interfaces";
  
  private static final String KEY_INTERFACES_SPILT = "HKEY_LOCAL_MACHINE";
  
  private static final String IP_ADDRESS = "IPAddress";
  
  private static final String SUB_NETMASK = "SubnetMask";
  
  private static final String DEFAULT_GATERY = "DefaultGateway";
  
  private static final String DHCP_IP_ADDRESS = "DhcpIPAddress";
  
  private static final String DHCP_SUB_NETMASK = "DhcpSubnetMask";
  
  private static final String DHCP_DEFAULT_GATERY = "DhcpDefaultGateway";
  
  private static final String DOT = ".";
  
  private static final String MAC_FF = "FF";
  
  private static final int MAC_PART_LENGTH = 5;
  
  private static final String MAC_START = "00";
  
  private static final String MAC_SEPARATOR = ":";
  
  private static final String HOST_FILE_PATH = "/etc/hosts";
  
  private static List<PCNetworkInfo> pcNetworkInfoList = new ArrayList<>();
  
  private static boolean queryNetworkInfo() {
    String temp = CmdUtils.getCmdResult("REG QUERY HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\services\\Tcpip\\Parameters\\Interfaces /s");
    if (temp == null || temp.isEmpty())
      return false; 
    getNetworkInfo(temp, true);
    getNetworkInfo(temp, false);
    return true;
  }
  
  private static void addPCNetworkInfo(String ip, String subnetMask, String gateway) {
    String lineSeparator = System.lineSeparator();
    String newIp = "";
    String newSubnetMask = "";
    String newGateway = "";
    if (ip.contains(lineSeparator))
      newIp = ip.substring(0, ip.indexOf(lineSeparator)); 
    if (subnetMask.contains(lineSeparator))
      newSubnetMask = subnetMask.substring(0, subnetMask.indexOf(lineSeparator)); 
    if (gateway.contains(lineSeparator))
      newGateway = gateway.substring(0, gateway.indexOf(lineSeparator)); 
    List<String> ipList = new ArrayList<>();
    for (int i = 0; i < pcNetworkInfoList.size(); i++)
      ipList.add(((PCNetworkInfo)pcNetworkInfoList.get(i)).getIp()); 
    boolean isAdd = (isValidIP(newIp) && !ipList.contains(newIp));
    if (isAdd) {
      PCNetworkInfo pCNetworkInfo = new PCNetworkInfo(newIp, newSubnetMask, newGateway);
      pcNetworkInfoList.add(pCNetworkInfo);
    } 
  }
  
  private static void getNetworkInfo(String networkInfo, boolean isDhcp) {
    String[] networkInfoList = networkInfo.split("HKEY_LOCAL_MACHINE");
    for (int i = 0; i < networkInfoList.length; i++) {
      if (networkInfoList[i].indexOf("IPAddress") != -1 || networkInfoList[i].indexOf("DhcpIPAddress") != -1) {
        String[] oneNetworkInfo = networkInfoList[i].split(" ");
        addInfo(oneNetworkInfo, isDhcp);
      } 
    } 
  }
  
  private static void addInfo(String[] oneNetworkInfo, boolean isDhcp) {
    String ipFlag = "IPAddress";
    String subnetMaskFlag = "SubnetMask";
    String gatewayFlag = "DefaultGateway";
    if (isDhcp) {
      ipFlag = "DhcpIPAddress";
      subnetMaskFlag = "DhcpSubnetMask";
      gatewayFlag = "DhcpDefaultGateway";
    } 
    String ip = "";
    String subnetMask = "";
    String gateway = "";
    for (int index = 0; index < oneNetworkInfo.length; index++) {
      if (oneNetworkInfo[index].equalsIgnoreCase(ipFlag))
        for (int j = index; j < oneNetworkInfo.length; j++) {
          if (oneNetworkInfo[j].indexOf(".") != -1) {
            ip = oneNetworkInfo[j];
            break;
          } 
        }  
      if (oneNetworkInfo[index].equalsIgnoreCase(subnetMaskFlag))
        for (int j = index; j < oneNetworkInfo.length; j++) {
          if (oneNetworkInfo[j].indexOf(".") != -1) {
            subnetMask = oneNetworkInfo[j];
            break;
          } 
        }  
      if (oneNetworkInfo[index].equalsIgnoreCase(gatewayFlag))
        for (int j = index; j < oneNetworkInfo.length; j++) {
          if (oneNetworkInfo[j].indexOf(".") != -1) {
            gateway = oneNetworkInfo[j];
            break;
          } 
        }  
    } 
    addPCNetworkInfo(ip, subnetMask, gateway);
  }
  
  private static List<String> getAllIPs() {
    pcNetworkInfoList.clear();
    List<String> result = new ArrayList<>();
    try {
      Enumeration<NetworkInterface> network = NetworkInterface.getNetworkInterfaces();
      if (network == null)
        return result; 
      while (network.hasMoreElements()) {
        NetworkInterface net = network.nextElement();
        Enumeration<InetAddress> inetAddresses = net.getInetAddresses();
        while (inetAddresses.hasMoreElements()) {
          InetAddress addr = inetAddresses.nextElement();
          result.add(addr.getHostAddress());
        } 
      } 
    } catch (SocketException socketException) {}
    if (!ToolUtils.isLinux())
      queryNetworkInfo(); 
    List<String> ipList = new ArrayList<>();
    for (int i = 0; i < pcNetworkInfoList.size(); i++)
      ipList.add(((PCNetworkInfo)pcNetworkInfoList.get(i)).getIp()); 
    for (String ip : ipList) {
      if (result.contains(ip))
        continue; 
      if (isValidIP(ip))
        result.add(ip); 
    } 
    return result;
  }
  
  public static String[] getServerIps() {
    List<String> allIPs = getAllIPs();
    List<String> ipv4 = new ArrayList<>();
    if (allIPs == null)
      return null; 
    for (String ip : allIPs) {
      if (ip.indexOf(":") != -1)
        continue; 
      if (ip.contains("127.0.0"))
        continue; 
      ipv4.add(ip);
    } 
    return ipv4.<String>toArray(new String[ipv4.size()]);
  }
  
  public static boolean isOnTheSameNetIP(String ip1, String ip2, String subnetMask) {
    StringTokenizer tokenizer1 = new StringTokenizer(ip1, ".");
    int countTokens = tokenizer1.countTokens();
    if (countTokens != 4)
      return false; 
    StringTokenizer tokenizer2 = new StringTokenizer(ip2, ".");
    countTokens = tokenizer2.countTokens();
    if (countTokens != 4)
      return false; 
    StringTokenizer tokenizerSubnetMask = new StringTokenizer(subnetMask, ".");
    countTokens = tokenizerSubnetMask.countTokens();
    if (countTokens != 4)
      return false; 
    for (int index = 0; index < 4; index++) {
      if (tokenizer1.hasMoreElements() && tokenizer2.hasMoreElements() && tokenizerSubnetMask
        .hasMoreElements()) {
        long tokenizer1L = Long.parseLong((String)tokenizer1
            .nextElement());
        long tokenizer2L = Long.parseLong((String)tokenizer2
            .nextElement());
        long tokenizerGatewayL = Long.parseLong((String)tokenizerSubnetMask.nextElement());
        if ((tokenizer1L & tokenizerGatewayL) != (tokenizer2L & tokenizerGatewayL))
          return false; 
      } else {
        return false;
      } 
    } 
    return true;
  }
  
  private static char generatorChar(Random random) {
    int ch = -1;
    while (ch == -1) {
      ch = random.nextInt(256);
      if ((ch >= 48 && ch <= 57) || (ch >= 97 && ch <= 102))
        break; 
      ch = -1;
    } 
    return (char)ch;
  }
  
  public static boolean isValidMac(String mac) {
    if (mac == null || mac.length() == 0)
      return false; 
    StringTokenizer sb = new StringTokenizer(mac, ":");
    if (sb.countTokens() != 6)
      return false; 
    int i = 0;
    while (sb.hasMoreElements()) {
      String nextToken = sb.nextToken();
      if (nextToken.length() != 2)
        return false; 
      try {
        Integer.parseInt(nextToken, 16);
      } catch (NumberFormatException e) {
        return false;
      } 
      int secondNumber = Integer.parseInt(nextToken.substring(1), 16);
      if (i == 0 && secondNumber % 2 != 0)
        return false; 
      i++;
    } 
    StringBuilder allIsZero = new StringBuilder();
    StringBuilder allIsFF = new StringBuilder();
    for (int j = 0; j < 5; j++) {
      allIsZero.append("00:");
      allIsFF.append("FF:");
    } 
    allIsZero.append("00");
    allIsFF.append("FF");
    if (allIsZero.toString().equalsIgnoreCase(mac) || allIsFF.toString().equalsIgnoreCase(mac))
      return false; 
    return true;
  }
  
  public static String generatorMAC() {
    Random random = new Random();
    StringBuilder sb = new StringBuilder("00");
    for (int i = 0; i < 5; i++) {
      sb.append(":");
      sb.append(generatorChar(random));
      sb.append(generatorChar(random));
    } 
    return sb.toString();
  }
  
  public static boolean isValidIP(String ip) {
    boolean black = isBlank(ip);
    if (black)
      return false; 
    StringTokenizer tokenizer1 = new StringTokenizer(ip, ".");
    int countTokens = tokenizer1.countTokens();
    if (countTokens != 4)
      return false; 
    if (ip.charAt(ip.length() - 1) == '.')
      return false; 
    for (int index = 0; index < countTokens; index++) {
      if (tokenizer1.hasMoreElements()) {
        Object nextElement = tokenizer1.nextElement();
        if (!(nextElement instanceof String))
          return false; 
        try {
          int parseInt = Integer.parseInt((String)nextElement);
          if (parseInt < 0 || parseInt > 255)
            return false; 
        } catch (Exception e) {
          return false;
        } 
      } 
    } 
    return true;
  }
  
  public static boolean isBlank(String ip) {
    if (ip == null || ip.trim().length() == 0)
      return true; 
    if (ip.startsWith("0") || ip.startsWith("127"))
      return true; 
    return "x.x.x.x".equals(ip);
  }
  
  public static List<PCNetworkInfo> getPCNetworkInfo() {
    try {
      List<String> ipList = getLocalMachineInfo("IP Address", "IPv4 地址");
      List<String> subnetMaskList = getLocalMachineInfo("Subnet Mask", "子网掩码");
      List<String> gatewayList = getLocalMachineInfo("Default Gateway", "默认网关");
      int ipSize = ipList.size();
      int subnetMaskSize = subnetMaskList.size();
      int gatewaySize = gatewayList.size();
      if (ipSize == subnetMaskSize) {
        String priorGateWay = "";
        for (int ipIndex = 0; ipIndex < ipList.size(); ipIndex++) {
          String ip = ipList.get(ipIndex);
          String subnetMask = subnetMaskList.get(ipIndex);
          String gateway = "";
          if (ipIndex >= gatewaySize) {
            gateway = priorGateWay;
          } else {
            gateway = gatewayList.get(ipIndex);
            if (gateway.isEmpty())
              gateway = ip.substring(0, ip.lastIndexOf(".")) + ".1"; 
            priorGateWay = gateway;
          } 
          PCNetworkInfo pcNetworkInfo = new PCNetworkInfo(ip, subnetMask, gateway);
          pcNetworkInfoList.add(pcNetworkInfo);
        } 
      } 
    } catch (Exception e) {
      Display.getDefault().syncExec((Runnable)new Object());
      return null;
    } 
    if (!ToolUtils.isLinux())
      queryNetworkInfo(); 
    return pcNetworkInfoList;
  }
  
  public static List<String> getLocalMachineInfo(String strEn, String strCh) {
    List<String> paramList = new ArrayList<>();
    String line = "";
    InputStream input = null;
    InputStreamReader inputRead = null;
    BufferedReader br = null;
    try {
      Process ps = null;
      String osName = System.getProperties().getProperty("os.name");
      if (osName.toLowerCase().startsWith("windows")) {
        ps = Runtime.getRuntime().exec("cmd /c ipconfig /all");
      } else if (osName.toLowerCase().startsWith("linux")) {
        ps = Runtime.getRuntime().exec("/bin/sh -c ipconfig /all");
      } else {
        ps = Runtime.getRuntime().exec("cmd /c ipconfig /all");
      } 
      input = ps.getInputStream();
      inputRead = new InputStreamReader(input, System.getProperty("file.encoding"));
      br = new BufferedReader(inputRead);
      while (null != (line = br.readLine())) {
        if (line.indexOf(strEn) != -1) {
          int n = line.indexOf(":");
          line = line.substring(n + 2);
          if (line.contains("("))
            line = line.substring(0, line.indexOf("(")); 
          if (line.contains(":")) {
            line = br.readLine();
            if (line != null)
              paramList.add(line.trim()); 
          } else {
            paramList.add(line);
          } 
        } 
        if (line != null && line.indexOf(strCh) != -1) {
          int n = line.indexOf(":");
          line = line.substring(n + 2);
          if (line.contains("("))
            line = line.substring(0, line.indexOf("(")); 
          if (line.contains(":")) {
            line = br.readLine();
            if (line != null)
              paramList.add(line.trim()); 
            continue;
          } 
          paramList.add(line);
        } 
      } 
      ps.waitFor();
    } catch (IOException e) {
      return paramList;
    } catch (Exception e) {
      return paramList;
    } finally {
      if (input != null)
        try {
          input.close();
        } catch (IOException iOException) {} 
      if (inputRead != null)
        try {
          inputRead.close();
        } catch (IOException iOException) {} 
      if (br != null)
        try {
          br.close();
        } catch (IOException iOException) {} 
    } 
    return paramList;
  }
  
  public static List<PCNetworkInfo> getPcNetworkInfoList() {
    return pcNetworkInfoList;
  }
  
  private static String getLocalHostIp() {
    List<String> allIPs = getAllIPs();
    if (allIPs == null)
      return ""; 
    for (String ip : allIPs) {
      if (ip.indexOf(":") != -1)
        continue; 
      if (ip.contains("127."))
        return ip; 
    } 
    return "";
  }
  
  public static boolean addHostName() {
    String hostName = CmdUtils.getCmdResult("hostname").trim();
    String ip = getLocalHostIp();
    if (hostName.isEmpty() || ip.isEmpty()) {
      Log.println("hostName or ip is empty ");
      return false;
    } 
    Log.println("hostName: " + hostName);
    Log.println("ip: " + ip);
    ArrayList<String> lines = FileUtils.readAllLines("/etc/hosts");
    if (lines == null) {
      Log.println("failed to read hostname");
      return false;
    } 
    for (String strLine : lines) {
      boolean isContinue = (strLine == null || strLine.isEmpty() || strLine.startsWith("#"));
      if (isContinue)
        continue; 
      if (strLine.indexOf(hostName) != -1 && strLine.indexOf(ip) != -1)
        return true; 
    } 
    String newLine = ip + " " + hostName;
    if (!FileUtils.writeLines(newLine, "/etc/hosts", "GBK")) {
      Log.println("failed to write hostname");
      return false;
    } 
    return true;
  }
  
  public static boolean isValidSubnetMask(String subnetMask) {
    String[] subnetMaskSplitArr = subnetMask.split("\\.");
    if (subnetMaskSplitArr.length != 4)
      return false; 
    String binaryString = "";
    for (String group : subnetMaskSplitArr) {
      int value;
      try {
        value = Integer.parseInt(group);
        String binary = Integer.toBinaryString(value);
        binaryString = binaryString + binaryString;
      } catch (NumberFormatException e) {
        return false;
      } 
      if (value < 0 || value > 255)
        return false; 
    } 
    int firstZeroIndex = binaryString.indexOf('0');
    int lastOneIndex = binaryString.lastIndexOf('1');
    if (firstZeroIndex == -1 || lastOneIndex == -1 || firstZeroIndex < lastOneIndex)
      return false; 
    return true;
  }
}
